/*******************************************************************************
* $Rev:  $
* $Author: $
* $Date: $
*******************************************************************************/

#ifndef _SUBROUTINES_H

#define _SUBROUTINES_H


/*******************************************************************************
| use C style in C++
*******************************************************************************/
#if defined(__cplusplus)
extern "C" {
#endif

/*******************************************************************************
* init the matrix A with values 
*******************************************************************************/
void initMatrix(double *const A, const int N);


/*******************************************************************************
* zero a vector x
*******************************************************************************/
void zeroVector(double *const x, const int N);


/*******************************************************************************
* init the vector x with values 
*******************************************************************************/
void initVector(double *const x, const int N);


/*******************************************************************************
* y = alpha*A.x + beta*y
*******************************************************************************/
void matVecMul(const double alpha, const double beta, 
               const double* __restrict__ A,
               const double* __restrict__ x,
               double *const __restrict__ y,
               const int N);


/*******************************************************************************
* calculate the norm of the vector x
*******************************************************************************/
double vecNorm(const double *x, const int N);


/*******************************************************************************
* use C style in C++
*******************************************************************************/
#if defined(__cplusplus)
}
#endif

#endif
