#include <time.h>

/* init the timer */
void init_timer();


/* print timer */
void print_timer();


/*------------------------------------------------------------------------------
| Stopwatch structure:
|  real_time   : time in seconds the timer was running till the last stop-call
|  time_start  : absolute time of the last continue-call
|  user_time   : time in seconds the timer was running till the last stop-call
|  clock_start : clock count of the last continue-call
|  running     : binary flag indicating the running status
------------------------------------------------------------------------------*/
typedef struct
{
  double  real_time;
  double  time_start;
  double  user_time;
  clock_t clock_start;
  int     running;
} Stopwatch;


extern void init_stopwatch(Stopwatch *stopwatch);

extern void cont_stopwatch(Stopwatch *stopwatch);

#define start_stopwatch(sw) (init_stopwatch(sw), cont_stopwatch(sw))


extern void stop_stopwatch(Stopwatch *stopwatch);

extern double read_stopwatch(Stopwatch *stopwatch);

extern double read_stopwatch_user(Stopwatch *stopwatch);

void msleep(double ms);
